﻿using UnityEngine;

public struct Cyborg
{
    public static AudioClip SpartanLaserCharge;
    public static AudioClip SpartanLaserFire;
    public static AudioClip SpartanLaserExit;

    public static AudioClip EnergySwordHum;
    public static AudioClip Hungry;
    public static AudioClip EnergySwordIgnite;
    public static AudioClip EnergySwordOff;
    public static AudioClip Boom;
    public static AudioClip Ha;
    public static AudioClip[] EnergySwordHits;
    public static AudioClip[] PlasmaPistolFire;
    public static AudioClip[] PlasmaRifleFire;
    public static AudioClip[] NeedleFire;
    public static AudioClip[] NeedleExplode;
    public static AudioClip PlasmaRifleOverheat;
    public static AudioClip PlasmaPistolChargeStart;
    public static AudioClip PlasmaPistolLoop;
    public static AudioClip PlasmaPistolChargedShot;

    public static Sprite EnergySwordHilt;
    public static Sprite EnergySwordBlade;
    public static Sprite EnergySwordHilt2;
    public static Sprite EnergySwordBlade2;
    public static Sprite New;
    public static Sprite EnergySwordHilt3;
    public static Sprite EnergySwordBlade3;
    public static Sprite EnergySwordHilt4;
    public static Sprite EnergySwordBlade5;
    public static Sprite EnergySwordHilt5;
    public static Sprite EnergySwordBlade55;
    public static Sprite EnergySwordBlade505;
    public static Sprite EnergySwordHilt55;
    public static Sprite EnergySwordBlade4;
    public static Sprite Red;
    public static Sprite Red2;
    public static Sprite Red23;
    public static Sprite Spear;
    public static Sprite Spear1;
    public static Sprite PlasmaPistol;
    public static Sprite SpartanLaser;
    public static Sprite PlasmaRifle;
    public static Sprite PlasmaRifleGlow;
    public static Sprite Needler;
    public static Sprite Needle;

    public static Sprite Particle;
    public static Sprite PlasmaBolt;
    public static Sprite EnergyFlash;

    public static void Initialise()
    {
        Particle = ModAPI.LoadSprite("spike.png");
        EnergyFlash = ModAPI.LoadSprite("flash.png");

        SpartanLaserCharge = ModAPI.LoadSound("sfx/spartan_laser_charge.wav");
        SpartanLaserFire = ModAPI.LoadSound("sfx/spartan_laser_fire.wav");
        SpartanLaserExit = ModAPI.LoadSound("sfx/spartan_laser_exit.wav");

        EnergySwordHum = ModAPI.LoadSound("Looping.wav");
        Hungry = ModAPI.LoadSound("rage.wav");
        EnergySwordIgnite = ModAPI.LoadSound("on.wav");
        EnergySwordOff = ModAPI.LoadSound("on.wav");

        Boom = ModAPI.LoadSound("tel.wav");
        Ha = ModAPI.LoadSound("ha.wav");


        PlasmaRifleOverheat = ModAPI.LoadSound("sfx/plasma_rifle_overheat.wav");

        PlasmaPistolChargeStart = ModAPI.LoadSound("sfx/plasma_pistol_start.wav");
        PlasmaPistolLoop = ModAPI.LoadSound("sfx/plasma_pistol_loop.wav");
        PlasmaPistolChargedShot = ModAPI.LoadSound("sfx/plasma_pistol_charged.wav");

        EnergySwordHits = new[]{
            ModAPI.LoadSound("sfx/energy_sword_impact1.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact2.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact3.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact4.wav"),
        };

        PlasmaPistolFire = new[]{
            ModAPI.LoadSound("sfx/plasma_pistol1.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol2.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol3.wav"),
        };

        PlasmaRifleFire = new[]{
            ModAPI.LoadSound("sfx/plasma_rifle1.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle2.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle3.wav"),
        };

        NeedleFire = new[]{
            ModAPI.LoadSound("sfx/needler_fire1.wav"),
            ModAPI.LoadSound("sfx/needler_fire2.wav"),
            ModAPI.LoadSound("sfx/needler_fire3.wav"),
        };

        NeedleExplode = new[]{
            ModAPI.LoadSound("sfx/needle_explode1.wav"),
            ModAPI.LoadSound("sfx/needle_explode2.wav"),
            ModAPI.LoadSound("sfx/needle_explode3.wav"),
        };

        EnergySwordHilt = ModAPI.LoadSprite("GreenSword.png");
        EnergySwordBlade = ModAPI.LoadSprite("SuperGreenSword.png");
        EnergySwordHilt2 = ModAPI.LoadSprite("hamburger.png");
        EnergySwordBlade2 = ModAPI.LoadSprite("hamburgerLightNew.png");
        EnergySwordHilt3 = ModAPI.LoadSprite("AxeFireLight.png");
        EnergySwordBlade3 = ModAPI.LoadSprite("BladeFire.png");
        EnergySwordHilt4 = ModAPI.LoadSprite("wand.png");
        EnergySwordBlade4 = ModAPI.LoadSprite("wandLight.png");
        EnergySwordHilt5 = ModAPI.LoadSprite("sper.png");
        EnergySwordBlade5 = ModAPI.LoadSprite("sperLight.png");
        EnergySwordHilt55 = ModAPI.LoadSprite("sper.png");
        EnergySwordBlade55 = ModAPI.LoadSprite("sperLight2.png");
        New = ModAPI.LoadSprite("hammerMiniLight.png");
        EnergySwordBlade505 = ModAPI.LoadSprite("SuperGreen.png");
        Red = ModAPI.LoadSprite("RedSwordLight.png");
        Red2 = ModAPI.LoadSprite("RedSword.png");
        Red23 = ModAPI.LoadSprite("FireSwordLight.png");
        Spear = ModAPI.LoadSprite("SpearusLightNew.png");
        Spear1 = ModAPI.LoadSprite("SpearusLight.png");
        PlasmaPistol = ModAPI.LoadSprite("Plasma Pistol.png");
        PlasmaRifle = ModAPI.LoadSprite("Plasma Rifle.png");
        PlasmaRifleGlow = ModAPI.LoadSprite("Plasma Rifle Glow.png");
        Needler = ModAPI.LoadSprite("SwordCyber.png");
        Needle = ModAPI.LoadSprite("BladeElec.png");
        SpartanLaser = ModAPI.LoadSprite("Potatus.png");
        PlasmaBolt = ModAPI.LoadSprite("th.png");
    }
}
