﻿using UnityEngine;

namespace Mod
{
    public class EMP7 : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.SetParent(hand.gameObject.transform);
            handGlow.transform.localPosition = Vector2.zero;
            handGlow.transform.localScale = Vector2.one;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 1f, 1f, 0.08f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 10;
                ModAPI.CreateParticleEffect("BlasterImpact", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
                ModAPI.CreateParticleEffect("Explosion", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
                other.transform.BroadcastMessage("Break", SendMessageOptions.DontRequireReceiver);
                other.transform.BroadcastMessage("Crush", SendMessageOptions.DontRequireReceiver);
                other.transform.BroadcastMessage("Disintegrate", SendMessageOptions.DontRequireReceiver);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 10;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 1f, 0.5f);
            }
        }
    }
}