﻿using UnityEngine;
    public class Fragment : MonoBehaviour
    {

        private GameObject hand;
        bool IsUsable = true;
        private GameObject handGlow;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.SetParent(hand.gameObject.transform);
            handGlow.transform.localPosition = Vector2.zero;
            handGlow.transform.localScale = Vector2.one;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("hammerLight.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(1f, 0f, 1.1f, 0.05f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -50f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 5;
                ModAPI.CreateParticleEffect("HugeZap", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
                ModAPI.CreateParticleEffect("PinkExplosion", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 5;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -50f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 1.1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 1.1f, 0.05f);
            }
        }
    }