﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public const float PixelSize = Global.MetricMultiplier / 35f;

        public static void Main()
        {
            AddUnique<EMP>("Yes", "No");
        }

        private static void AddUnique<T>(string name, string desc, string original = "Rod") where T : Component
        {
            Cyborg.Initialise();  

            CategoryBuilder.Create("CFM", "", ModAPI.LoadSprite("weird.png"));

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Sword"), //item to derive from
        NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Electric Sword", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use its full power! If thor had a sword instead of a hammer", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb14.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("GreenSword.png");

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("GreenSword.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
                        childSprite.sortingLayerName = "Default";

            Instance.GetOrAddComponent<Awake1NEW>();
            Instance.GetOrAddComponent<EMP16>();
            Instance.GetOrAddComponent<T>();

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(0f, 0.6f, 1f, 0.1f);
                        line.sortingOrder = -1;

                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("SuperGreenSword.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(0, 100, 100, 100);

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Sword"), //item to derive from
        NameOverride = "CTTC- <color=orange>(Fire Faction)<color=white> Cybernetic Fire Sword", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to make it on fire!", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb31.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("FireSword.png");

                       Instance.GetOrAddComponent<EMP39>();

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.12f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.12f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(2f, 0.1f, 0f, 0.1f);
                        line.sortingOrder = -3;


            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
        NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Sword", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use it! Goopy lightsaber", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb18.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Green.png");


            Instance.GetOrAddComponent<EMP24>();

                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("SuperGreen.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(0, 100, 0, 100);

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Sword"), //item to derive from
        NameOverride = "CTTC- <color=blue>(Plasma Faction)<color=blue> Cybernetic Plasma Sword", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use its huge blade!", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb26.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("PlasmaSword.png");


            Instance.GetOrAddComponent<EMP30>();

                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("PlasmaSwordBlade.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(100, 0, 150, 100);

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "CTTC- <color=orange>(Fire Faction)<color=white> Cybernetic Double-Ended Flame Axe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use its 2 blades on each sides!", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb30.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AxeFire.png");
            Instance.GetOrAddComponent<EMP37>();
            Instance.GetOrAddComponent<EMP38>();

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Rope Shooter", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to grab things with a rope!", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb19.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Roper.png");
            Instance.GetOrAddComponent<EMPNEW3>();
            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Trident", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use it! Goopy Trident", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb17.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Trident.png");


            Instance.GetOrAddComponent<EMP26>();

                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("SuperTrident.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(0, 100, 0, 100);

            Instance.FixColliders();
        }
    }
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Electric Spear", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "ok", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb12.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Spearus.png");

            Instance.GetOrAddComponent<EMP21>();

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.05f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(0f, 0.6f, 1f, 0.1f);
                        line.sortingOrder = -5;


                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("SpearusLight.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(0, 100, 100, 100);

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Cybernetic Spear", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "ok", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb13.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Spearus.png");

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.05f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(1f, 0f, 0f, 0.1f);
                        line.sortingOrder = -5;


                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("SpearusLightNew.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(100, 0, 0, 100);
            Instance.GetOrAddComponent<EMP20>();

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"), //item to derive from
        NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Electric Hammer", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Big Electric HamHam", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb11.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("tel2.wav")};
Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hammer.png");
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 10f;
            Instance.GetOrAddComponent<EMP4>();

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(0f, 0.5f, 1f, 0.1f);
                        line.sortingOrder = -1;

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"), //item to derive from
        NameOverride = "CTTC- <color=orange>(Fire Faction)<color=white> Cybernetic Fire Hammer", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Big Fire HamHam", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb35.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("tel2.wav")};
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hammerFire.png");
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 10f;
            Instance.GetOrAddComponent<EMP36>();

                       Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.12f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.12f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(2f, 0.1f, 0f, 0.2f);
                        line.sortingOrder = -1;

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"), //item to derive from
        NameOverride = "CTTC- <color=blue>(Plasma Faction)<color=blue> Cybernetic Plasma Hammer", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Big Plasma HamHam", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb24.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("tel2.wav")};
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hammerPLASMA.png");
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 10f;
            Instance.GetOrAddComponent<Fragment>();
            Instance.GetOrAddComponent<PlasFrag>();
Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.2f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(1f, 0f, 1.1f, 0.1f);
                        line.sortingOrder = -2;

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"), //item to derive from
        NameOverride = "CTTC- <color=blue>(Plasma Faction)<color=blue> Cybernetic Plasma Sword-Hammer", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to turn the hammer into a regular size sword!", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb25.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hammerMini.png");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 2f;
            Instance.GetOrAddComponent<EMP29>();
            Instance.GetOrAddComponent<Awake1>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("hammerMiniLight.png");
            Instance.GetComponent<Brighten>().Colour = new Color32(100, 0, 100, 100);
            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
        NameOverride = "CTTC- <color=white>(PROP) Plasma Fragment", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sus1.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Frag.png");

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("FragS.png");
                        childSprite.color = new Color(1f, 1f, 1f, 1f);
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.sortingLayerName = "Top";

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
        NameOverride = "CTTC- <color=white>(PROP) Heat Fragment", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sus5.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Frag.png");

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("FragFire.png");
                        childSprite.color = new Color(1f, 0.75f, 0f, 0.5f);
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.sortingLayerName = "Top";

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
        NameOverride = "CTTC- <color=white>(PROP) Cyber Fragment", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sus2.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Frag.png");

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("FragS.png");
                        childSprite.color = new Color(1f, 0f, 0f, 1f);
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.sortingLayerName = "Top";

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
        NameOverride = "CTTC- <color=white>(PROP) Electric Fragment", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sus3.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Frag.png");

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("FragS.png");
                        childSprite.color = new Color(0f, 1f, 1f, 1f);
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.sortingLayerName = "Top";

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
        NameOverride = "CTTC- <color=white>(PROP) Ion Fragment", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sus4.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Frag.png");

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("FragS.png");
                        childSprite.color = new Color(0f, 1f, 0f, 1f);
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.sortingLayerName = "Top";

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"), //item to derive from
        NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Hammer", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Big Ionic HamHam", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb16.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("tel2.wav")};
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hammerIon.png");
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 11f;
            Instance.GetOrAddComponent<EMP28>();
Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.15f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(0f, 1f, 0f, 0.1f);
                        line.sortingOrder = -10;

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Sword"), //item to derive from
        NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Cybernetic Sword", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to make it able to explode the stabed objects! *gets sliced in half* -oh srry i didnt see ya there", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb1.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RedSword.png");


                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(1f, 0f, 0f, 0.1f);
                        line.sortingOrder = -1;

            Instance.GetOrAddComponent<EMP12>();
            Instance.GetOrAddComponent<EMP15>();
                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("RedSwordLight.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(100, 0, 0, 100);


            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "èé", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "lmao how did you find this (unless ur looking the codes)", //new item description
        CategoryOverride = ModAPI.FindCategory(""), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned                                                                  
        {           
                        UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
                        useEventTrigger.Event = new UnityEvent();
                        useEventTrigger.Event.AddListener(delegate ()
                        {
                       ModAPI.CreateParticleEffect("HugeExplosion", new Vector2(Instance.transform.position.x, Instance.transform.position.y + 0.5f));
                        });
                                                                                                                            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cat.png");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            Instance.AddComponent<TEST1>();
            Instance.transform.localScale = new Vector3(1.3f, 1.3f);
                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("Sprites-Default").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(0.4f, 0.4f, 0.4f, 0.1f);
                        line.sortingOrder = -10;

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Cybernetic Wand", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use the Explosion Spell! ", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb2.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hamburger.png");

            Instance.GetOrAddComponent<EMP8>();
            Instance.GetOrAddComponent<EMP5>();

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(1f, 0f, 0f, 0.1f);
                        line.sortingOrder = -5;

                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("hamburgerLightNew.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(100, 0, 0, 100);


            Instance.FixColliders();
        }
    }
);

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Cybernetic Blade And Cannon Robot",
                    DescriptionOverride = "Activate his front hand to activate/desactivate the Blade and activate his back hand to shoot Powerful Bolts! He is a mixture of the rope-blade robot and the super-puncher robot",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb5.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm2;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("Cannon.png");
                        eySprite.material = ModAPI.FindMaterial("Sprites-Default");
                        eySprite.color = new Color(1f, 1f, 1f, 1f);
                        eySprite.sortingLayerName = "default";


                               arm1.gameObject.AddComponent<EMP13>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 0f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(1f, 0f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var skin = ModAPI.LoadTexture("skinos.png");
                        var flesh = ModAPI.LoadTexture("cyber.png");
                        var bone = ModAPI.LoadTexture("cyberbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        var eye = ModAPI.CreateLight(middle, Color.red, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }

            foreach (var item in person.Limbs)
            {
                 if (item.gameObject.name == "BackArm" || item.gameObject.name == "LowerArm")
                {
                    item.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                    {

                        GameObject Brink = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt.ShallowClone());
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.red;
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.red;
                        Brink.GetComponent<BlasterboltBehaviour>().ImpactStrength = 50f;
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.colorGradient = new Gradient();
                        Brink.transform.localScale += new Vector3(4.1f, 4.5f, 0);
                        /*
                        foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            Physics2D.IgnoreCollision(item.GetComponent<Collider2D>(), Brink.GetComponent<Collider2D>());
                       }
                        */
                        ModAPI.CreateParticleEffect("Explosion", item.gameObject.transform.position);
                        // item.gameObject.GetComponent<AudioSource>().clip = Sound;
                        item.gameObject.GetComponent<AudioSource>().Play();
                        Brink.transform.position = item.gameObject.transform.position;
                        Brink.transform.eulerAngles = item.gameObject.transform.eulerAngles;
                        if (person.transform.localScale.x < 0)
                            Brink.transform.eulerAngles += new Vector3(0, 0, 270);
                        else Brink.transform.eulerAngles += new Vector3(0, 0, -90);
                        AudioSource audio = item.gameObject.AddComponent<AudioSource>();
                        AudioClip Sound = ModAPI.LoadSound("tel.wav");
                        audio.spatialBlend = 15;
                    };
                }
            }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=blue>(Plasma Faction)<color=blue> Cybernetic Plasma Rope Robot",
                    DescriptionOverride = "Activate his hands to shoot a plasma rope that will make the items slowely go up in the air!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb27.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");

                               arm1.gameObject.AddComponent<hammer>();
                               arm2.gameObject.AddComponent<hammer>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 0f, 1f, 0.095f);
                        wingsprite.sortingLayerName = "Default";

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(1f, 0f, 1f, 0.15f);
                        wingprite.sortingLayerName = "Default";

                        var skin = ModAPI.LoadTexture("skinosP.png");
                        var flesh = ModAPI.LoadTexture("cyberP.png");
                        var bone = ModAPI.LoadTexture("cyberboneP.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Shotgun Arms Robot",
                    DescriptionOverride = "Activate one of his arms to shoot Ionic shotgun bolts!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb22.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 1f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 1f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var skin = ModAPI.LoadTexture("skinosIon.png");
                        var flesh = ModAPI.LoadTexture("cyberIon.png");
                        var bone = ModAPI.LoadTexture("cyberboneIon.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("Lighten.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(0f, 1f, 0f, 0.08f);
                        eySprite.sortingLayerName = "Top";

                        GameObject alsoEyr = new GameObject();
                        alsoEyr.transform.parent = arm2;
                        alsoEyr.transform.localPosition = new Vector3(0f, 0f);
                        alsoEyr.transform.localScale = new Vector3(1f, 1f);

                        var eySpriter = alsoEyr.AddComponent<SpriteRenderer>();

                        eySpriter.sprite = ModAPI.LoadSprite("lighten.png");
                        eySpriter.material = ModAPI.FindMaterial("VeryBright");
                        eySpriter.color = new Color(0f, 1f, 0f, 0.08f);
                        eySpriter.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.green, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            ModAPI.CreateParticleEffect("IonExplosion", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }

            foreach (var item in person.Limbs)
            {
                 if (item.gameObject.name == "BackArm" || item.gameObject.name == "LowerArm" || item.gameObject.name == "FrontArm" || item.gameObject.name == "LowerArmFront")
                {
                    item.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                    {
                        GameObject Brink = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt.ShallowClone());
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.colorGradient = new Gradient();
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.green;
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.green;
                        Brink.GetComponent<BlasterboltBehaviour>().ImpactStrength = 85f;
                        Brink.transform.localScale += new Vector3(4.1f, 4.5f, 0);
                        /*
                        foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            Physics2D.IgnoreCollision(item.GetComponent<Collider2D>(), Brink.GetComponent<Collider2D>());
                       }
                        */
                        // item.gameObject.GetComponent<AudioSource>().clip = Sound;
                        ModAPI.CreateParticleEffect("IonExplosion", item.gameObject.transform.position);
                        item.gameObject.GetComponent<AudioSource>().Play();
                        Brink.transform.position = item.gameObject.transform.position;
                        Brink.transform.eulerAngles = item.gameObject.transform.eulerAngles;
                        if (person.transform.localScale.x < 0)
                            Brink.transform.eulerAngles += new Vector3(0, 0, 270);
                        else Brink.transform.eulerAngles += new Vector3(0, 0, -95);
                        AudioSource audio = item.gameObject.AddComponent<AudioSource>();
                        AudioClip Sound = ModAPI.LoadSound("tel.wav");
                        audio.spatialBlend = 15;
                    };
                }
            }

             foreach (var item in person.Limbs)
            {
                 if (item.gameObject.name == "BackArm" || item.gameObject.name == "LowerArm" || item.gameObject.name == "FrontArm" || item.gameObject.name == "LowerArmFront")
                {
                    item.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                    {
                        GameObject Brink = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt.ShallowClone());
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.colorGradient = new Gradient();
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.green;
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.green;
                        Brink.GetComponent<BlasterboltBehaviour>().ImpactStrength = 85f;
                        Brink.transform.localScale += new Vector3(4.1f, 4.5f, 0);
                        /*
                        foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            Physics2D.IgnoreCollision(item.GetComponent<Collider2D>(), Brink.GetComponent<Collider2D>());
                       }
                        */
                        // item.gameObject.GetComponent<AudioSource>().clip = Sound;
                        ModAPI.CreateParticleEffect("IonExplosion", item.gameObject.transform.position);
                        item.gameObject.GetComponent<AudioSource>().Play();
                        Brink.transform.position = item.gameObject.transform.position;
                        Brink.transform.eulerAngles = item.gameObject.transform.eulerAngles;
                        if (person.transform.localScale.x < 0)
                            Brink.transform.eulerAngles += new Vector3(0, 0, 270);
                        else Brink.transform.eulerAngles += new Vector3(0, 0, -85);
                        AudioSource audio = item.gameObject.AddComponent<AudioSource>();
                        AudioClip Sound = ModAPI.LoadSound("tel.wav");
                        audio.spatialBlend = 15;
                    };
                }
            }

             foreach (var item in person.Limbs)
            {
                 if (item.gameObject.name == "BackArm" || item.gameObject.name == "LowerArm" || item.gameObject.name == "FrontArm" || item.gameObject.name == "LowerArmFront")
                {
                    item.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                    {
                        GameObject Brink = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt.ShallowClone());
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.colorGradient = new Gradient();
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.green;
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.green;
                        Brink.GetComponent<BlasterboltBehaviour>().ImpactStrength = 85f;
                        Brink.transform.localScale += new Vector3(4.1f, 4.5f, 0);
                        /*
                        foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            Physics2D.IgnoreCollision(item.GetComponent<Collider2D>(), Brink.GetComponent<Collider2D>());
                       }
                        */
                        // item.gameObject.GetComponent<AudioSource>().clip = Sound;
                        ModAPI.CreateParticleEffect("IonExplosion", item.gameObject.transform.position);
                        item.gameObject.GetComponent<AudioSource>().Play();
                        Brink.transform.position = item.gameObject.transform.position;
                        Brink.transform.eulerAngles = item.gameObject.transform.eulerAngles;
                        if (person.transform.localScale.x < 0)
                            Brink.transform.eulerAngles += new Vector3(0, 0, 270);
                        else Brink.transform.eulerAngles += new Vector3(0, 0, -90);
                        AudioSource audio = item.gameObject.AddComponent<AudioSource>();
                        AudioClip Sound = ModAPI.LoadSound("tel.wav");
                        audio.spatialBlend = 15;
                    };
                }
            }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Beam Robot",
                    DescriptionOverride = "Activate his Arms to shoot a powerful Ionic beam!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb20.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");


                               arm1.gameObject.AddComponent<EMP23>();
                               arm2.gameObject.AddComponent<EMP23>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 1f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 1f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("Lighten.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(0f, 1f, 0f, 0.08f);
                        eySprite.sortingLayerName = "Top";

                        GameObject alsoEyr = new GameObject();
                        alsoEyr.transform.parent = arm2;
                        alsoEyr.transform.localPosition = new Vector3(0f, 0f);
                        alsoEyr.transform.localScale = new Vector3(1f, 1f);

                        var eySpriter = alsoEyr.AddComponent<SpriteRenderer>();

                        eySpriter.sprite = ModAPI.LoadSprite("lighten.png");
                        eySpriter.material = ModAPI.FindMaterial("VeryBright");
                        eySpriter.color = new Color(0f, 1f, 0f, 0.08f);
                        eySpriter.sortingLayerName = "default";

                        var skin = ModAPI.LoadTexture("skinosIon.png");
                        var flesh = ModAPI.LoadTexture("cyberIon.png");
                        var bone = ModAPI.LoadTexture("cyberboneIon.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        var eye = ModAPI.CreateLight(middle, Color.green, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            ModAPI.CreateParticleEffect("IonExplosion", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Fists Robot",
                    DescriptionOverride = "Punch things to make them weightless and shiny!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb23.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");


                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("handfreeze.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(0f, 1f, 0f, 0.08f);
                        eySprite.sortingLayerName = "Top";

                        GameObject alsoEyr = new GameObject();
                        alsoEyr.transform.parent = arm2;
                        alsoEyr.transform.localPosition = new Vector3(0f, 0f);
                        alsoEyr.transform.localScale = new Vector3(1f, 1f);

                        var eySpriter = alsoEyr.AddComponent<SpriteRenderer>();

                        eySpriter.sprite = ModAPI.LoadSprite("handfreeze.png");
                        eySpriter.material = ModAPI.FindMaterial("VeryBright");
                        eySpriter.color = new Color(0f, 1f, 0f, 0.08f);
                        eySpriter.sortingLayerName = "default";

                            arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0.2f);
                            arm1.gameObject.GetOrAddComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                            arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0.2f);
                            arm2.gameObject.GetOrAddComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                            arm1.gameObject.AddComponent<EMPNEW2>();
                            arm2.gameObject.AddComponent<EMPNEW2>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 1f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 1f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var skin = ModAPI.LoadTexture("skinosIon2.png");
                        var flesh = ModAPI.LoadTexture("cyberIon.png");
                        var bone = ModAPI.LoadTexture("cyberboneIon.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        var eye = ModAPI.CreateLight(middle, Color.green, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            ModAPI.CreateParticleEffect("IonExplosion", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=green>(Ion Faction)<color=white> Cybernetic Ionic Rope Robot",
                    DescriptionOverride = "Activate his arms to shoot ionic ropes that will burn the skin of the aimed entity!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb21.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("Lighten.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(0f, 1f, 0f, 0.08f);
                        eySprite.sortingLayerName = "Top";

                        GameObject alsoEyr = new GameObject();
                        alsoEyr.transform.parent = arm2;
                        alsoEyr.transform.localPosition = new Vector3(0f, 0f);
                        alsoEyr.transform.localScale = new Vector3(1f, 1f);

                        var eySpriter = alsoEyr.AddComponent<SpriteRenderer>();

                        eySpriter.sprite = ModAPI.LoadSprite("lighten.png");
                        eySpriter.material = ModAPI.FindMaterial("VeryBright");
                        eySpriter.color = new Color(0f, 1f, 0f, 0.08f);
                        eySpriter.sortingLayerName = "default";


                               arm1.gameObject.GetOrAddComponent<EMP25>();
                               arm2.gameObject.GetOrAddComponent<EMP25>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 1f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 1f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var skin = ModAPI.LoadTexture("skinosIon.png");
                        var flesh = ModAPI.LoadTexture("cyberIon.png");
                        var bone = ModAPI.LoadTexture("cyberboneIon.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        var eye = ModAPI.CreateLight(middle, Color.green, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            ModAPI.CreateParticleEffect("IonExplosion", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Cybernetic Rope-Saber Robot",
                    DescriptionOverride = "Activate his hands to shoot ropes that will slice the limbs of the aimed Entity! Badass moment here",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinos.png");
                        var flesh = ModAPI.LoadTexture("cyber.png");
                        var bone = ModAPI.LoadTexture("cyberbone.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("Lighten.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(1f, 0f, 0f, 0.2f);
                        eySprite.sortingLayerName = "Top";

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(1f, 0f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 0f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.red, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                               arm1.gameObject.AddComponent<EMP9>();
                               arm2.gameObject.AddComponent<EMP9>();


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "CTTC- <color=white>(BONUS)<color=white> X",
                    DescriptionOverride = "if you activate my head i will lose all of my body exept the head and then if u activate it again i will get my body reconstructed! frien :)",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbonus3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("X.png");
                        var flesh = ModAPI.LoadTexture("X.png");
                        var bone = ModAPI.LoadTexture("X.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");

                               head.gameObject.AddComponent<TEST3>();


                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);
                        var wingsprite = wings.AddComponent<SpriteRenderer>();
                        wingsprite.sprite = ModAPI.LoadSprite("Xeye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 1f, 1f, 0.095f);
                        wingsprite.sortingLayerName = "Top";

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            UseEventTrigger useEventTrigger21 = head.gameObject.AddComponent<UseEventTrigger>();
                            useEventTrigger21.Event = new UnityEvent();
                            useEventTrigger21.Event.AddListener(delegate ()
                              {
                            ModAPI.CreateParticleEffect("Spark", new Vector2(body.transform.position.x, body.transform.position.y + 0f));
                            body.transform.BroadcastMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                            body.transform.BroadcastMessage("Slice", SendMessageOptions.DontRequireReceiver);
                            Destroy(body.gameObject.GetComponent<BoxCollider2D>());
                            });
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "éè", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "", //new item description
        CategoryOverride = ModAPI.FindCategory(""), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumbonus3.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("smile.png");

            Instance.GetOrAddComponent<TEST4>();

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Xeye.png");
                        childSprite.color = new Color(1f, 1f, 1f, 0.05f);
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.sortingLayerName = "Top";

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("Sprites-Default").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(1f, 1f, 1f, 0.1f);
                        line.sortingOrder = -3;

            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Electric-Rope Robot",
                    DescriptionOverride = "Activate his hands to shoot ropes that will Over-Charge the limbs of the aimed Entity! CLEAR!!!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb10.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosElec.png");
                        var flesh = ModAPI.LoadTexture("blueber.png");
                        var bone = ModAPI.LoadTexture("blueberdead.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");


                               arm1.gameObject.AddComponent<EMP17>();
                               arm2.gameObject.AddComponent<EMP17>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 0.8f, 1f, 0.08f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 0.8f, 1f, 0.1f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.cyan, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);



                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            ModAPI.CreateParticleEffect("HugeZap", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Electric Gigabot",
                    DescriptionOverride = "This is a Giant Electricity Robot... What can i say more?",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb9.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosElecBig.png");
                        var flesh = ModAPI.LoadTexture("skinosElecBig.png");
                        var bone = ModAPI.LoadTexture("skinosElecBig.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");


head.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -2.5f;
upper.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -8f;

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 0.5f, 1f, 0.18f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 0.5f, 1f, 0.18f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.cyan, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);



                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 7f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.transform.root.localScale *= 1.2f;
                            body.gameObject.AddComponent<EMP3>();
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += float.MaxValue;
                ModAPI.CreateParticleEffect("HugeZap", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Blades Robot",
                    DescriptionOverride = "Activate his Arms to use the blades!  Very stylish.",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb7.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosElec.png");
                        var flesh = ModAPI.LoadTexture("blueber.png");
                        var bone = ModAPI.LoadTexture("blueberdead.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");


                               arm1.gameObject.AddComponent<EMP18>();
                               arm2.gameObject.AddComponent<EMP19>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 0.8f, 1f, 0.08f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 0.8f, 1f, 0.1f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.cyan, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);



                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            ModAPI.CreateParticleEffect("HugeZap", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=orange>(Fire Faction)<color=white> Cybernetic Fire Rope Robot",
                    DescriptionOverride = "Activate his hands to shoot a very hot rope that will burn everything it attaches to!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb33.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosFire.png");
                        var flesh = ModAPI.LoadTexture("skinosFire.png");
                        var bone = ModAPI.LoadTexture("cyberFire.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");

                        ModAPI.CreateParticleEffect("BlasterImpact", new Vector2(middle.transform.position.x, middle.transform.position.y + -0.5f));
                        arm1.gameObject.AddComponent<RopeFire>();
                        arm2.gameObject.AddComponent<RopeFire>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(2f, 0.1f, 0f, 1f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(2f, 0.1f, 0f, 1f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.yellow, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);



                        foreach (var body in person.Limbs)
                        {
                            body.gameObject.AddComponent<FireTouch>();
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=orange>(Fire Faction)<color=white> Cybernetic Fire Blades Robot",
                    DescriptionOverride = "Activate his Arms to use the blades!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb34.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosFire.png");
                        var flesh = ModAPI.LoadTexture("skinosFire.png");
                        var bone = ModAPI.LoadTexture("cyberFire.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");


                        arm1.gameObject.AddComponent<EMP34>();
                        arm2.gameObject.AddComponent<EMP35>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(2f, 0.1f, 0f, 1f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(2f, 0.1f, 0f, 1f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.yellow, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        ModAPI.CreateParticleEffect("BlasterImpact", new Vector2(middle.transform.position.x, middle.transform.position.y + -0.5f));

                        foreach (var body in person.Limbs)
                        {
                            body.gameObject.AddComponent<FireTouch>();
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=orange>(Fire Faction)<color=white> Cybernetic Heat-Blast Robot",
                    DescriptionOverride = "Activate his Arms to shoot a VERY hot blast!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb32.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosFire.png");
                        var flesh = ModAPI.LoadTexture("skinosFire.png");
                        var bone = ModAPI.LoadTexture("cyberFire.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");


                        arm1.gameObject.AddComponent<EMP33>();
                        arm2.gameObject.AddComponent<EMP33>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(2f, 0.1f, 0f, 1f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(2f, 0.1f, 0f, 1f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.yellow, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        ModAPI.CreateParticleEffect("BlasterImpact", new Vector2(middle.transform.position.x, middle.transform.position.y + -0.5f));

                        foreach (var body in person.Limbs)
                        {
                            body.gameObject.AddComponent<FireTouch>();
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Electric-Explosion Robot",
                    DescriptionOverride = "Activate his Arms to make him shoot a Invisible Electric Blast! Power of destruction",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb8.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosElec.png");
                        var flesh = ModAPI.LoadTexture("blueber.png");
                        var bone = ModAPI.LoadTexture("blueberdead.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");
                        arm1.gameObject.AddComponent<EMP22>();
                        arm2.gameObject.AddComponent<EMP22>();

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(0f, 0.8f, 1f, 0.08f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(0f, 0.8f, 1f, 0.1f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.cyan, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);



                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            ModAPI.CreateParticleEffect("HugeZap", new Vector2(body.transform.position.x, body.transform.position.y + -0.5f));
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }


                        arm1.gameObject.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Lighten.png");
                        arm1.gameObject.GetComponent<Brighten>().Colour = new Color32(0, 100, 100, 100);
                        arm2.gameObject.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Lighten.png");
                        arm2.gameObject.GetComponent<Brighten>().Colour = new Color32(0, 100, 100, 100);
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Cybernetic Ultrabot",
                    DescriptionOverride = "Activate his hands to shoot a Invisible Blast that will burn every Entity it is aiming + Freeze CFM or Objects for eternity on touch (even the floor)",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb6.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinos3.png");
                        var flesh = ModAPI.LoadTexture("cyber.png");
                        var bone = ModAPI.LoadTexture("cyberbone.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("handfreeze.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(1f, 0f, 0f, 0.08f);
                        eySprite.sortingLayerName = "Top";

                        GameObject alsoEyr = new GameObject();
                        alsoEyr.transform.parent = arm2;
                        alsoEyr.transform.localPosition = new Vector3(0f, 0f);
                        alsoEyr.transform.localScale = new Vector3(1f, 1f);

                        var eySpriter = alsoEyr.AddComponent<SpriteRenderer>();

                        eySpriter.sprite = ModAPI.LoadSprite("handfreeze.png");
                        eySpriter.material = ModAPI.FindMaterial("VeryBright");
                        eySpriter.color = new Color(1f, 0f, 0f, 0.08f);
                        eySpriter.sortingLayerName = "default";

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(1f, 0f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 0f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.red, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                               arm1.gameObject.AddComponent<EMP14>();
                               arm2.gameObject.AddComponent<EMP14>();
                               arm1.gameObject.AddComponent<Awake4>();
                               arm2.gameObject.AddComponent<Awake4>();


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
			    body.ImmuneToDamage = true;
			    body.CirculationBehaviour.ImmuneToDamage = true;
			    body.PhysicalBehaviour.Disintegratable = false;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.transform.root.localScale *= 1.018f;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=blue>(Plasma Faction)<color=blue> Cybernetic Plasma Fist Robot",
                    DescriptionOverride = "Activate his front hand to use his plasma fist!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb28.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosP.png");
                        var flesh = ModAPI.LoadTexture("cyberP.png");
                        var bone = ModAPI.LoadTexture("cyberboneP.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("handfreezeP.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(1f, 0f, 1f, 0.08f);
                        eySprite.sortingLayerName = "Top";

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(1f, 0f, 1f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 0f, 1f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.blue, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        arm1.gameObject.AddComponent<EMP32>();


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
			    body.ImmuneToDamage = true;
			    body.CirculationBehaviour.ImmuneToDamage = true;
			    body.PhysicalBehaviour.Disintegratable = false;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=blue>(Plasma Faction)<color=blue> Cybernetic Plasma Beam Robot",
                    DescriptionOverride = "Activate his hands to use his plasma fists!",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb29.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinosP.png");
                        var flesh = ModAPI.LoadTexture("cyberP.png");
                        var bone = ModAPI.LoadTexture("cyberboneP.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm1;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("handfreezeP.png");
                        eySprite.material = ModAPI.FindMaterial("VeryBright");
                        eySprite.color = new Color(1f, 0f, 1f, 0.08f);
                        eySprite.sortingLayerName = "Top";

                        GameObject alsoEyr = new GameObject();
                        alsoEyr.transform.parent = arm2;
                        alsoEyr.transform.localPosition = new Vector3(0f, 0f);
                        alsoEyr.transform.localScale = new Vector3(1f, 1f);

                        var eySpriter = alsoEyr.AddComponent<SpriteRenderer>();

                        eySpriter.sprite = ModAPI.LoadSprite("handfreezeP.png");
                        eySpriter.material = ModAPI.FindMaterial("VeryBright");
                        eySpriter.color = new Color(1f, 0f, 1f, 0.08f);
                        eySpriter.sortingLayerName = "default";

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(1f, 0f, 1f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 0f, 1f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.blue, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        arm1.gameObject.AddComponent<EMP31>();
                        arm2.gameObject.AddComponent<EMP31>();


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
			    body.ImmuneToDamage = true;
			    body.CirculationBehaviour.ImmuneToDamage = true;
			    body.PhysicalBehaviour.Disintegratable = false;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Cybernetic Super-Puncher Robot",
                    DescriptionOverride = "Activate his Fists to shoot a bolt with a enormous impact strength and punch things to explode them!  Big boi also means Big Fists",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb4.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var skin = ModAPI.LoadTexture("skinos2.png");
                        var flesh = ModAPI.LoadTexture("cyber.png");
                        var bone = ModAPI.LoadTexture("cyberbone.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");

                        upper.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -4.95f;

                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = arm2;
                        alsoEy.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("Fist.png");
                        eySprite.material = ModAPI.FindMaterial("Sprites-Default");
                        eySprite.color = new Color(1f, 1f, 1f, 1f);
                        eySprite.sortingLayerName = "Default";

                       GameObject wing = new GameObject();
                        wing.transform.parent = upper;
                        wing.transform.localPosition = new Vector4(0f, 0f);
                        wing.transform.localScale = new Vector4(1f, 1f);

                        var wingprite = wing.AddComponent<SpriteRenderer>();

                        wingprite.sprite = ModAPI.LoadSprite("cape3.png");
                        wingprite.material = ModAPI.FindMaterial("VeryBright");
                        wingprite.color = new Color(1f, 0f, 0f, 0.15f);
                        wingprite.sortingLayerName = "default";

                        GameObject alsoEy2 = new GameObject();
                        alsoEy2.transform.parent = arm1;
                        alsoEy2.transform.localPosition = new Vector3(0f, 0f);
                        alsoEy2.transform.localScale = new Vector3(1f, 1f);

                        var eySprite2 = alsoEy2.AddComponent<SpriteRenderer>();

                        eySprite2.sprite = ModAPI.LoadSprite("FistFront.png");
                        eySprite2.material = ModAPI.FindMaterial("Sprites-Default");
                        eySprite2.color = new Color(1f, 1f, 1f, 1f);
                        eySprite2.sortingLayerName = "Top";

                       GameObject wings = new GameObject();
                        wings.transform.parent = head;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("eye.png");
                        wingsprite.material = ModAPI.FindMaterial("VeryBright");
                        wingsprite.color = new Color(1f, 0f, 0f, 0.095f);
                        wingsprite.sortingLayerName = "default";

                        var eye = ModAPI.CreateLight(middle, Color.red, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                               arm1.gameObject.AddComponent<EMP7>();
                               arm2.gameObject.AddComponent<EMP7>();

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += float.MaxValue;
                            body.InitialHealth += float.MaxValue;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= -100000f;
                            body.transform.root.localScale *= 1.065f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 505f;
                            body.RegenerationSpeed += float.MaxValue;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }


            foreach (var item in person.Limbs)
            {
                 if (item.gameObject.name == "FrontArm" || item.gameObject.name == "LowerArmFront" || item.gameObject.name == "BackArm" || item.gameObject.name == "LowerArm")
                {
                    item.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                    {

                        GameObject Brink = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt.ShallowClone());
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.red;
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.red;
                        Brink.GetComponent<BlasterboltBehaviour>().ImpactStrength = 100000f;
                        Brink.GetComponent<BlasterboltBehaviour>().Trail.colorGradient = new Gradient();
                        Brink.transform.localScale += new Vector3(4.1f, 4.5f, 0);
                        /*
                        foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            Physics2D.IgnoreCollision(item.GetComponent<Collider2D>(), Brink.GetComponent<Collider2D>());
                       }
                        */
                        ModAPI.CreateParticleEffect("Explosion", item.gameObject.transform.position);
                        // item.gameObject.GetComponent<AudioSource>().clip = Sound;
                        item.gameObject.GetComponent<AudioSource>().Play();
                        Brink.transform.position = item.gameObject.transform.position;
                        Brink.transform.eulerAngles = item.gameObject.transform.eulerAngles;
                        if (person.transform.localScale.x < 0)
                            Brink.transform.eulerAngles += new Vector3(0, 0, 270);
                        else Brink.transform.eulerAngles += new Vector3(0, 0, -90);
                        AudioSource audio = item.gameObject.AddComponent<AudioSource>();
                        AudioClip Sound = ModAPI.LoadSound("tel.wav");
                        audio.spatialBlend = 15;
                    };
                }
            }
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "CTTC- <color=blue>(Electric Faction)<color=white> Cybernetic Electric Wand", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to shoot a electric spell! (activate again to stop it)", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb15.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {


                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(0f, 0.5f, 1f, 0.1f);
                        line.sortingOrder = -5;


                               Instance.AddComponent<EMP2>();
                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("wandLight.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(0, 100, 100, 100);

            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("wand.png");
            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Crystal"), //item to derive from
        NameOverride = "CTTC- <color=red>(Classic Faction)<color=white> Double-Ended Cybernetic Dagger", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use it! cttc321's favourite CFM weapon", //new item description
        CategoryOverride = ModAPI.FindCategory("CFM"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = Color.clear;
                        line.startColor = new Color(1f, 0f, 0f, 0.1f);
                        line.sortingOrder = -5;

                               Instance.GetOrAddComponent<EMP10>();
                               Instance.GetOrAddComponent<EMP6>();

                        Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("sperLight.png");
                        Instance.GetComponent<Brighten>().Colour = new Color32(100, 0, 0, 100);

Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sper.png");
            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=white>(BONUS)<color=white> CTTC321",
                    DescriptionOverride = "if you activate my head i will lose all of my body exept the head and then if u activate it again i will get my body reconstructed! i am the creator of this mod",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbonus1.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");

                        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
                        useEventTrigger.Event = new UnityEvent();
                        useEventTrigger.Event.AddListener(delegate ()
                        {
                       ModAPI.CreateParticleEffect("FuseBlown", new Vector2(upper.transform.position.x, upper.transform.position.y + 0.5f));
                       ModAPI.CreateParticleEffect("BigExplosion", new Vector2(middle.transform.position.x, middle.transform.position.y + 0.5f));
                        });

                            head.gameObject.AddComponent<TEST2>();
head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        GameObject alsoEy = new GameObject();
                        alsoEy.transform.parent = upper;
                        alsoEy.transform.localPosition = new Vector3(0f, 0.25f);
                        alsoEy.transform.localScale = new Vector3(1f, 1f);

                        var eySprite = alsoEy.AddComponent<SpriteRenderer>();

                        eySprite.sprite = ModAPI.LoadSprite("catplate.png");
                        eySprite.material = ModAPI.FindMaterial("Sprites-Default");
                        eySprite.color = new Color(1f, 1f, 1f, 1f);
                        eySprite.sortingLayerName = "default";

                        var skin = ModAPI.LoadTexture("cttc.png");
                        var flesh = ModAPI.LoadTexture("cttc.png");
                        var bone = ModAPI.LoadTexture("cttc.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 10000000000;
                            body.InitialHealth += 10000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -1000f;
                            UseEventTrigger useEventTrigger21 = head.gameObject.AddComponent<UseEventTrigger>();
                            useEventTrigger21.Event = new UnityEvent();
                            useEventTrigger21.Event.AddListener(delegate ()
                              {
                            ModAPI.CreateParticleEffect("Spark", new Vector2(body.transform.position.x, body.transform.position.y + 0f));
                            body.transform.BroadcastMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                            body.transform.BroadcastMessage("Slice", SendMessageOptions.DontRequireReceiver);
                            Destroy(body.gameObject.GetComponent<BoxCollider2D>());
                            });
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "CTTC- <color=white>(BONUS)<color=white> TERMINATOR CTTC321",
                    DescriptionOverride = "the creator of this mod",
                    CategoryOverride = ModAPI.FindCategory("CFM"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbonus2.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var head = Instance.transform.Find("Head");


                        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
                        useEventTrigger.Event = new UnityEvent();
                        useEventTrigger.Event.AddListener(delegate ()
                        {
                        });

                        GameObject alsoEye1 = new GameObject();
                        alsoEye1.transform.parent = head;
                        alsoEye1.transform.localPosition = new Vector3(0f, -0.02f);
                        alsoEye1.transform.localScale = new Vector3(1f, 1f);

                        var eyeSprite1 = alsoEye1.AddComponent<SpriteRenderer>();

                        eyeSprite1.sprite = ModAPI.LoadSprite("eyescary.png");
                        eyeSprite1.material = ModAPI.FindMaterial("VeryBright");
                        eyeSprite1.color = new Color(1f, 0f, 0f, 0.05f);
                        eyeSprite1.sortingLayerName = "Top";

head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                        var skin = ModAPI.LoadTexture("cttcerminator.png");
                        var flesh = ModAPI.LoadTexture("cttcerminator.png");
                        var bone = ModAPI.LoadTexture("cttcerminator.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 1, 2); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(1, 5, 6); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(1, 5, 6);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 10000000000;
                            body.InitialHealth += 10000000000;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -1000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.RegenerationSpeed += 1000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
}
        private static void AddBurstFirearm(string name, string desc, string cartridge, AudioClip[] sounds = null, Vector2 barrelPosPixels = default(Vector2), float interval = 0.42f, int amount = 3, Vector3[] holdingPositions = null)
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = name + " [zooi]",
                    NameToOrderByOverride = "Halo" + name,
                    DescriptionOverride = desc,
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite(name + " view.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var gun = Instance.GetComponent<FirearmBehaviour>();
                        gun.Automatic = false;
                        gun.barrelPosition = barrelPosPixels * Mod.PixelSize;
                        if (sounds != null)
                            gun.ShotSounds = sounds;

                        gun.Cartridge = ModAPI.FindCartridge(cartridge);

                        foreach (var coll in Instance.GetComponents<Collider2D>())
                            UnityEngine.Object.Destroy(coll);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(name + ".png");
                        Instance.AddComponent<BoxCollider2D>();
                        BurstFireAdapter burst = Instance.GetOrAddComponent<BurstFireAdapter>();
                        burst.Interval = interval;
                        burst.BurstCount = amount;

                       if (holdingPositions != null)
                            Instance.GetOrAddComponent<PhysicalBehaviour>().HoldingPositions = holdingPositions;
                        Instance.GetOrAddComponent<DrawGrabPoints>();
                    }
                }
            );
        }
    }
    public struct Cyborg2
    {
        public static void OnLoad()
        {
        Cyborg.Particle = ModAPI.LoadSprite("spike.png");
        Cyborg.EnergyFlash = ModAPI.LoadSprite("flash.png");

        Cyborg.SpartanLaserCharge = ModAPI.LoadSound("sfx/spartan_laser_charge.wav");
        Cyborg.SpartanLaserFire = ModAPI.LoadSound("sfx/spartan_laser_fire.wav");
        Cyborg.SpartanLaserExit = ModAPI.LoadSound("sfx/spartan_laser_exit.wav");

        Cyborg.EnergySwordHum = ModAPI.LoadSound("Looping.wav");
        Cyborg.Hungry = ModAPI.LoadSound("rage.wav");
        Cyborg.EnergySwordIgnite = ModAPI.LoadSound("on.wav");
        Cyborg.EnergySwordOff = ModAPI.LoadSound("on.wav");

        Cyborg.Boom = ModAPI.LoadSound("tel.wav");
        Cyborg.Ha = ModAPI.LoadSound("ha.wav");


        Cyborg.PlasmaRifleOverheat = ModAPI.LoadSound("sfx/plasma_rifle_overheat.wav");

        Cyborg.PlasmaPistolChargeStart = ModAPI.LoadSound("sfx/plasma_pistol_start.wav");
        Cyborg.PlasmaPistolLoop = ModAPI.LoadSound("sfx/plasma_pistol_loop.wav");
        Cyborg.PlasmaPistolChargedShot = ModAPI.LoadSound("sfx/plasma_pistol_charged.wav");

        Cyborg.EnergySwordHits = new[]{
            ModAPI.LoadSound("sfx/energy_sword_impact1.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact2.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact3.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact4.wav"),
        };

        Cyborg.PlasmaPistolFire = new[]{
            ModAPI.LoadSound("sfx/plasma_pistol1.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol2.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol3.wav"),
        };

        Cyborg.PlasmaRifleFire = new[]{
            ModAPI.LoadSound("sfx/plasma_rifle1.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle2.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle3.wav"),
        };

        Cyborg.NeedleFire = new[]{
            ModAPI.LoadSound("sfx/needler_fire1.wav"),
            ModAPI.LoadSound("sfx/needler_fire2.wav"),
            ModAPI.LoadSound("sfx/needler_fire3.wav"),
        };

        Cyborg.NeedleExplode = new[]{
            ModAPI.LoadSound("sfx/needle_explode1.wav"),
            ModAPI.LoadSound("sfx/needle_explode2.wav"),
            ModAPI.LoadSound("sfx/needle_explode3.wav"),
        };

        Cyborg.EnergySwordHilt = ModAPI.LoadSprite("GreenSword.png");
        Cyborg.EnergySwordBlade = ModAPI.LoadSprite("SuperGreenSword.png");
        Cyborg.EnergySwordHilt2 = ModAPI.LoadSprite("hamburger.png");
        Cyborg.EnergySwordBlade2 = ModAPI.LoadSprite("hamburgerLightNew.png");
        Cyborg.EnergySwordHilt3 = ModAPI.LoadSprite("Energy Sword3.png");
        Cyborg.EnergySwordBlade3 = ModAPI.LoadSprite("Energy Sword Blade2.png");
        Cyborg.EnergySwordHilt4 = ModAPI.LoadSprite("wand.png");
        Cyborg.EnergySwordBlade4 = ModAPI.LoadSprite("wandLight.png");
        Cyborg.EnergySwordHilt5 = ModAPI.LoadSprite("sper.png");
        Cyborg.EnergySwordBlade5 = ModAPI.LoadSprite("sperLight.png");
        Cyborg.EnergySwordHilt55 = ModAPI.LoadSprite("sper.png");
        Cyborg.EnergySwordBlade55 = ModAPI.LoadSprite("sperLight2.png");
        Cyborg.EnergySwordBlade505 = ModAPI.LoadSprite("SuperGreen.png");
        Cyborg.Red = ModAPI.LoadSprite("RedSwordLight.png");
        Cyborg.Red2 = ModAPI.LoadSprite("RedSword.png");
        Cyborg.Spear = ModAPI.LoadSprite("SpearusLightNew.png");
        Cyborg.Spear1 = ModAPI.LoadSprite("SpearusLight.png");
        Cyborg.PlasmaPistol = ModAPI.LoadSprite("Plasma Pistol.png");
        Cyborg.PlasmaRifle = ModAPI.LoadSprite("Plasma Rifle.png");
        Cyborg.Needler = ModAPI.LoadSprite("SwordCyber.png");
        Cyborg.Needle = ModAPI.LoadSprite("BladeElec.png");
        Cyborg.SpartanLaser = ModAPI.LoadSprite("Spartan Laser.png");
        Cyborg.PlasmaBolt = ModAPI.LoadSprite("th.png");
            }
        }
    }
    public class DrawGrabPoints : MonoBehaviour
    {
        private PhysicalBehaviour phys;

        private void Awake()
        {
            phys = GetComponent<PhysicalBehaviour>();
        }

        private void OnWillRenderObject()
        {
            #if else
            foreach (var item in phys.HoldingPositions)
            {
                ModAPI.Draw.Circle(transform.TransformPoint(item), .1f);
            }
            #endif
        }
    }
    public class Brighten : MonoBehaviour
    {
        public bool Activated = false;
        public GameObject Paint = new GameObject("Lighter");
        public Color32 Colour;
        public float TargetCharge = 0f;
        public Sprite PaintSprite;
        public LightSprite Light;

        public void UpdateGlow()
        {
            if(Activated == true)
            {
                Light.Brightness = 2f;
                Paint.GetComponent<SpriteRenderer>().color = Colour;
            }
            else if(Activated == false)
            {
                Light.Brightness = 0f;
                Paint.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 0, 0);
            }
        }

        void Start()
        {
            Paint.transform.parent = gameObject.transform;
            Paint.transform.rotation = gameObject.transform.rotation;
            Paint.transform.localPosition = new Vector3(0f, 0f);
            Paint.transform.localScale = new Vector3(1f, 1f);

            var Sprite = Paint.GetOrAddComponent<SpriteRenderer>();
            Sprite.sprite = PaintSprite;
            Sprite.material = ModAPI.FindMaterial("VeryBright");
            Sprite.color = new Color32(0, 0, 0, 0);

            Sprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder = +50;

            Light = ModAPI.CreateLight(gameObject.transform, new Color32(Colour.r, Colour.g, Colour.b, 255), 3f, 0f);
            UpdateGlow();
        }

        void Use() 
        {
            Activated = !Activated;
            UpdateGlow();
        }

        void Update() 
        {
            if(Activated == true)
            {
            }
            else
            {
            }
        }
    }
    public class Brighten2 : MonoBehaviour
    {
        public bool Activated = false;
        public GameObject Paint = new GameObject("Lighter");
        public Color32 Colour;
        public float TargetCharge = 0f;
        public Sprite PaintSprite;
        public LightSprite Light;

        public void UpdateGlow()
        {
            if(Activated == true)
            {
                Light.Brightness = 2f;
                Paint.GetComponent<SpriteRenderer>().color = Colour;
            }
            else if(Activated == false)
            {
                Light.Brightness = 0f;
                Paint.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 0, 0);
            }
        }

        void Start()
        {
            Paint.transform.parent = gameObject.transform;
            Paint.transform.rotation = gameObject.transform.rotation;
            Paint.transform.localPosition = new Vector3(0f, 0f);
            Paint.transform.localScale = new Vector3(1f, 1f);

            var Sprite = Paint.GetOrAddComponent<SpriteRenderer>();
            Sprite.sprite = PaintSprite;
            Sprite.material = ModAPI.FindMaterial("VeryBright");
            Sprite.color = new Color32(0, 0, 0, 0);

            Sprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder = -10;

            Light = ModAPI.CreateLight(gameObject.transform, new Color32(Colour.r, Colour.g, Colour.b, 255), 3f, 0f);
            UpdateGlow();
        }

        void Use() 
        {
            Activated = !Activated;
            UpdateGlow();
        }

        void Update() 
        {
            if(Activated == true)
            {
            }
            else
            {
            }
        }
    }

    public class BurstFireAdapter : MonoBehaviour
    {
        public float Interval = 0.1f;
        public int BurstCount = 3;

        private bool busy = false;

        private FirearmBehaviour firearm;

        private void Awake()
        {
            firearm = GetComponent<FirearmBehaviour>();
        }

        private void Use()
        {
            StartCoroutine(Burst());
        }

        private System.Collections.IEnumerator Burst()
        {
            if (busy) yield break;
            busy = true;
            for (int i = 0; i < BurstCount - 1; i++)
            {
                yield return new WaitForSeconds(Interval);
                firearm.Shoot();
            }
            busy = false;
    }
}
    public class EMPNEW2 : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.SetParent(hand.gameObject.transform);
            handGlow.transform.localPosition = Vector2.zero;
            handGlow.transform.localScale = Vector2.one;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("handfreeze.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 1f, 0f, 0.08f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100000f)
            {
                    ModAPI.CreateParticleEffect("IonExplosion", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
                    other.gameObject.GetComponent<LimbBehaviour>().Frozen = true;
                    other.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 0f, 0.1f);
                    other.gameObject.GetComponent<PhysicalBehaviour>().Temperature = -30f;
                    other.gameObject.GetOrAddComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
            }
            else
            {
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100000f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0.5f);
            }
        }
    }

public class EMPNEW3 : CanShoot
    {
        private bool isFired = false;

        public Vector2 barrelPosition = new Vector2(0f, 0.2f);
        public Vector2 barrelDirection = new Vector2(0f, 10f);

        private Vector2 firstVector;
        private Rigidbody2D firstRB;

        public AudioClip[] audioClips;

        public override Vector2 BarrelPosition
        {
            get
            {
                return transform.TransformPoint(barrelPosition);
            }
        }

        public Vector2 BarrelDirection
        {
            get
            {
                return transform.TransformDirection((barrelDirection.x) * transform.localScale.y, (barrelDirection.y), transform.localPosition.z);
            }
        }

        public void Awake()
        {
                    AudioClip[] audioClips = new AudioClip[]
                    {
                    ModAPI.LoadSound("sfx/tel.wav")
                    };
                    this.gameObject.AddComponent<AudioSource>();
        }

        void Use()
        {
            Shoot();
        }

        public override void Shoot() //telek
        {

            if (!isFired) //check to see if its in recall state
            {

                RaycastHit2D hit = Physics2D.Raycast(BarrelPosition, BarrelDirection, 1500f); //fire raycast

                if (hit.collider != null) //if oof
                {

                    DistanceJoint2D joint = this.gameObject.AddComponent<DistanceJoint2D>();
                    joint.maxDistanceOnly = true;
                    joint.enableCollision = true;
                    joint.distance = 1f;
                    joint.autoConfigureDistance = true;
                    joint.breakForce = Mathf.Infinity;
                    joint.breakTorque = Mathf.Infinity;

                    joint.connectedBody = hit.collider.gameObject.GetComponent<Rigidbody2D>();
                    firstRB = joint.connectedBody;

                    joint.connectedAnchor = hit.transform.InverseTransformPoint(hit.point);
                    firstVector = joint.connectedAnchor;

                    JointCreated(joint);

                    isFired = !isFired;

                    this.gameObject.GetComponent<AudioSource>().Play();
                }
            }
            else
            {

                RaycastHit2D hit2 = Physics2D.Raycast(BarrelPosition, BarrelDirection, 1500f); //fire raycast

                if (hit2.collider != null)
                {
                    foreach (var yeah in this.gameObject.GetComponents<DistanceJoint2D>()){Destroy(yeah);}
                    foreach (var mhm in this.gameObject.GetComponents<EnergyWireBehaviour>()){Destroy(mhm);}
                    isFired = !isFired;

                    this.gameObject.GetComponent<AudioSource>().Play();
                }

            }
        }

        void Update()
        {

        }

        void JointCreated(DistanceJoint2D joint)
        {
EnergyWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<EnergyWireBehaviour>();
energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/FixedCable");
energyWireBehaviour.WireMaterial = ModAPI.FindMaterial("VeryBright");
energyWireBehaviour.WireColor = new Color(0f, 1f, 0f, 0.06f);
energyWireBehaviour.WireWidth = 0.1f;
energyWireBehaviour.typedJoint = joint;
ModAPI.CreateParticleEffect("IonExplosion", new Vector2(energyWireBehaviour.transform.position.x, energyWireBehaviour.transform.position.y + 0.1f));
}}public class PlasFrag : MonoBehaviour{bool IsUsable = true;void OnCollisionEnter2D(Collision2D other){if(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude >= 1f && other.collider.gameObject.layer == LayerMask.NameToLayer("Objects") && IsUsable)
{Instantiate(ModAPI.FindSpawnable("Crystal").Prefab, other.transform.position, Quaternion.identity);Destroy(other.gameObject.transform.root.gameObject);}
  }
}
    public class Awake1NEW : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.SetParent(hand.gameObject.transform);
            handGlow.transform.localPosition = Vector2.zero;
            handGlow.transform.localScale = Vector2.one;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("GreenSwordLight.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 1f, 1f, 0.05f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -80f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 2;
ModAPI.CreateParticleEffect("Spark", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
ModAPI.CreateParticleEffect("BigZap", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 2;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -80f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 1f, 0.05f);
            }
        }
    }

public class RopeFire : CanShoot
    {
        private bool isFired = false;

        public Vector2 barrelPosition = new Vector2(0f, -0.2f);
        public Vector2 barrelDirection = new Vector2(0f, -10f);

        private Vector2 firstVector;
        private Rigidbody2D firstRB;

        public AudioClip[] audioClips;

        public override Vector2 BarrelPosition
        {
            get
            {
                return transform.TransformPoint(barrelPosition);
            }
        }

        public Vector2 BarrelDirection
        {
            get
            {
                return transform.TransformDirection((barrelDirection.x) * transform.localScale.y, (barrelDirection.y), transform.localPosition.z);
            }
        }

        public void Awake()
        {
                    AudioClip[] audioClips = new AudioClip[]
                    {
                    ModAPI.LoadSound("on.wav")
                    };
                    this.gameObject.AddComponent<AudioSource>();
        }

        void Use()
        {
            Shoot();
        }

        public override void Shoot() //telek
        {

            if (!isFired) //check to see if its in recall state
            {

                RaycastHit2D hit = Physics2D.Raycast(BarrelPosition, BarrelDirection, 1500f); //fire raycast

                if (hit.collider != null) //if oof
                {

                    DistanceJoint2D joint = this.gameObject.AddComponent<DistanceJoint2D>();
                    joint.maxDistanceOnly = true;
                    joint.enableCollision = true;
                    joint.distance = 1f;
                    joint.autoConfigureDistance = true;
                    joint.breakForce = Mathf.Infinity;
                    joint.breakTorque = Mathf.Infinity;

                    joint.connectedBody = hit.collider.gameObject.GetComponent<Rigidbody2D>();
                    firstRB = joint.connectedBody;

                    joint.connectedAnchor = hit.transform.InverseTransformPoint(hit.point);
                    firstVector = joint.connectedAnchor;
                    hit.transform.GetComponent<PhysicalBehaviour>().Temperature = 5000000000000f;
                    hit.transform.GetComponent<PhysicalBehaviour>().burnIntensity = 110000f;

                    JointCreated(joint);

                    isFired = !isFired;

                    this.gameObject.GetComponent<AudioSource>().Play();
                }
            }
            else
            {

                RaycastHit2D hit2 = Physics2D.Raycast(BarrelPosition, BarrelDirection, 1500f); //fire raycast

                if (hit2.collider != null)
                {
                    foreach (var yeah in this.gameObject.GetComponents<DistanceJoint2D>()){Destroy(yeah);}
                    foreach (var mhm in this.gameObject.GetComponents<EnergyWireBehaviour>()){Destroy(mhm);}
                    isFired = !isFired;

                    this.gameObject.GetComponent<AudioSource>().Play();
                }

            }
        }

        void Update()
        {

        }

        void JointCreated(DistanceJoint2D joint)
        {
EnergyWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<EnergyWireBehaviour>();
energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/FixedCable");
energyWireBehaviour.WireMaterial = ModAPI.FindMaterial("VeryBright");
energyWireBehaviour.WireColor = new Color(2f, 0.1f, 0f, 1f);
energyWireBehaviour.WireWidth = 0.12f;
energyWireBehaviour.typedJoint = joint;
ModAPI.CreateParticleEffect("BlasterImpact", new Vector2(energyWireBehaviour.transform.position.x, energyWireBehaviour.transform.position.y + 0.1f));
  }
}

public class FireTouch : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0.5f, 1f, 1f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100000f)
            {
                other.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 3000f;
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
                ModAPI.CreateParticleEffect("Flash", new Vector2(hand.transform.position.x, hand.transform.position.y + -0.5f));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100000f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }